/*
linphone
Copyright (C) 2000  Simon MORLAT (simon.morlat@free.fr)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef MISC_H
#define MISC_H

#include "linphonecore.h"

int set_lock_file();
int get_lock_file();
int remove_lock_file();
int linphone_arts_suspend();
int linphone_arts_restore();
int kill_sound_daemons();
void restore_sound_daemons();
int try_open_dsp(LinphoneCore *lc);
int linphone_core_set_alias(LinphoneCore *lc);
int linphone_core_update_contact_info(LinphoneCore *lc);
gint do_registration(LinphoneCore *lc, gboolean doit);
gint do_subscription(LinphoneCore *lc, char *callee, char *event_package, char *mimetype, gboolean doit);
void check_for_registration(LinphoneCore *lc);
void check_subscriptions(LinphoneCore *lc);
char *int2str(int number);
int from_2char_without_params(from_t *from,char **str);
void check_sound_device(LinphoneCore *lc);
void linphone_core_check_codecs_for_bandwidth(LinphoneCore *lc);
void linphone_core_setup_local_rtp_profile(LinphoneCore *lc);



#endif
